#ifdef GL_ES
precision mediump float;
#endif

// 1
varying vec2 v_texCoord;
uniform sampler2D u_texture;
uniform vec3 v_rgb;

void main()
{ // 2
    vec4 normalColor = texture2D(u_texture, v_texCoord).rgba;

	float rampedR = normalColor.r;
    float rampedG = normalColor.g;
    float rampedB = normalColor.b;
	float alpha = normalColor.a;

	if (normalColor.a > 0.0) {
		rampedR = normalColor.r + v_rgb[0] * normalColor.a;
		if (rampedR > 1.0)
			rampedR = 1.0;

		rampedG = normalColor.g + v_rgb[1] * normalColor.a;
		if (rampedG > 1.0)
			rampedG = 1.0;

		rampedB = normalColor.b + v_rgb[2] * normalColor.a;
		if (rampedB > 1.0)
			rampedB = 1.0;
	}
	
    // 4
    gl_FragColor = vec4(rampedR, rampedG, rampedB, alpha);
}